{#MG Modification Début 20200217#}
{% extends "@Paa/Default/entityFormBase.html.twig" %}
{#{% if psTitreColNom is not defined %}
    {% if psType_Res == "AB" %}
        {% set psTitreColNom = 'Participants' %}
    {% else %}
        {% set psTitreColNom = 'Nom' %}
    {% endif %}
{% endif %}
{% if pbAfficheCapacité is not defined %}
    {% if psType_Res == "I" or psType_Res == "S" %}
        {% set pbAfficheCapacité  = true %}
    {% else %}
        {% set pbAfficheCapacité = false %}
    {% endif %}
{% endif %}#}
{% block identification %}
{# LG 20200601 old    <div id="fEntityForm_{{ psNomTable }}_IdentifiantEntité" style="display:none;"></div>#}
    <div id="fEntityForm_{{ psNomTable }}_IdentifiantEntité" style="display:none;">{{ poSéance.id }}</div>
{% endblock %}


{% block formulaire %}	
    {# LG 20200508 début : input qui indique dans quel onglet on se trouve#}
    <input type="hidden" name="OngletSérie" id="OngletSérie" value="1">
    {# LG 20200508 fin#}
	
    <div class="container">
        <div class="row">
            <div class="col-sm-9">
                <input id="cbo2Dates2" type="text" data-role="cbo2Dates" data-speed = "true" class="btn cbo2Dates nav btn-default">
            </div>
        </div>
        <div class="row">
{#MG Modification 20200519 Fin#}
			{% if poForm.ifrequence is defined %}
			<div class="form-group col-sm-3">
				{{ form_label(poForm.ifrequence, "Récurrence : ", {'label_attr': {'class': 'control-label'}}) }}
				<div id="ifrequence" class="">
					{{ form_widget(poForm.ifrequence, {'attr': {'class': 'form-control'}}) }}
				</div>
			</div>
		{% endif %}
{#MG Modification 20200519 Fin#}
            {#<div class="col-sm-3">
                <label>
                    <input type="checkbox" id="afficherRessources">Afficher les ressources
                </label>
            </div>#}
        </div>
        <br>
        <div class="row">
            <div class="col-sm-4">
                {% if poForm.lexclutsamedi is defined %}
                    {{ form_label(poForm.lexclutsamedi, "Exclure les samedis", {'label_attr': {'class': 'col-sm-8 control-label'}}) }}
                    <div id="lexclutsamedi" class="">
                        {{ form_widget(poForm.lexclutsamedi, {'attr': {'class': 'form-control'}}) }}
                    </div>         
                {% endif %}
                {% if poForm.lexclutdimanche is defined %}
                    {{ form_label(poForm.lexclutdimanche, "Exclure les dimanches", {'label_attr': {'class': 'col-sm-8 control-label'}}) }}
                    <div id="lexclutdimanche" class="">
                        {{ form_widget(poForm.lexclutdimanche, {'attr': {'class': 'form-control'}}) }}
                    </div>       
                {% endif %}
                {% if poForm.lexclutjoursferies is defined %}
                    {{ form_label(poForm.lexclutjoursferies, "Exclure les jours fériés", {'label_attr': {'class': 'col-sm-8 control-label'}}) }}
                    <div id="lexclutjoursferies" class="">
                        {{ form_widget(poForm.lexclutjoursferies, {'attr': {'class': 'form-control'}}) }}
                    </div>      
                {% endif %}
            </div>
            <div class="col-sm-8">
                {% block Grille %}
                    <div class="LGDataTablesCoche">
                        <div id = "entityFormBaseGrille_DataTableInfos"></div>
                        <table id="entityFormBaseGrille_DataTable_{{psNomType_Res}}" class="display" cellspacing="0" width="100%" >
                            <thead>
                                <tr id="entityFormBaseGrille_DataTableTitres"> <!-- iTable_Form_titres -->
                                    {% block datatable_title %}
                                        <th id="trier" style="display: none"></th>
                                        <th id="selectionner">Selectionné pour prolongation</th>
                                        <th id="date">Date</th>
                                        <th id="heuredebut">Début</th>
                                        <th id="heurefin">Fin</th>                                                 
                                        <th id="ressources">Ressources</th>
									{% endblock %}
                                </tr>
                            </thead>
                            <tbody>
                            </tbody>
                        </table>
                        <div id='{{ psNomType_Res }}_Info' class='col-md-6' style='padding-top: 0.755em;'></div>
                        <div class='col-md-3'></div>
                        <div id='{{ psNomType_Res }}_Filter' class='col-md-3' style='padding-top: 0.755em;'></div>
                    </div>
                {% endblock %}
            </div>
        </div>
        <div class="row" style = 'display : none'>                      			
            {% if poForm.ddebut is defined %}
                <div class="form-group col-sm-4">
                    {{ form_label(poForm.ddebut, "De ", {'label_attr': {'class': 'control-label'}}) }}
                    <div id="ddebut" class="">
                        {{ form_widget(poForm.ddebut, {'attr': {'class': 'form-control'}}) }}
                    </div>
                </div>
            {% endif %}
            {% if poForm.dfin is defined %}
                <div class="form-group col-sm-4">
                    {{ form_label(poForm.dfin, "A ", {'label_attr': {'class': 'control-label'}}) }}
                    <div id="dfin" class="">
                        {{ form_widget(poForm.dfin, {'attr': {'class': 'form-control'}}) }}
                    </div>
                </div>
            {% endif %}
        </div>
    </div>


    <link type="text/css" href="//gyrocode.github.io/jquery-datatables-checkboxes/1.2.11/css/dataTables.checkboxes.css" rel="stylesheet" />
    <script type="text/javascript" src="//gyrocode.github.io/jquery-datatables-checkboxes/1.2.11/js/dataTables.checkboxes.min.js"></script>
    <script>
        $(document).ready(function(){
			cbo2DatesLoad(document.getElementById('cbo2Dates2'), "right");
			speedWidgetLoad(document.getElementById('cbo2Dates2'));
			var lsNomEntité = "{{ psNomType_Res }}";
			tmp_onLGDataTableInitComplete = function (poLGDataTable) {};
			// Construire la datatable
			LGDataTable_initGrille("entityFormBaseGrille_DataTable_{{ psNomType_Res }}", lsNomEntité, {}, tmp_onLGDataTableInitComplete);
			// Handle click on checkbox to set state of "Select all" control
			$('#entityFormBaseGrille_DataTable_{{ psNomType_Res }} tbody').on('change', 'input[type="checkbox"]', function () {
				// If checkbox is not checked
				actiBasesCompétences_ToggleCompétence('{{ psNomType_Res }}', this);
			});
			// Handle click on "Select all" control
			$('#select-all-{{ psType_Res }}').on('click', function () {
				// Check/uncheck all checkboxes in the table
				actiBasesCompétences_ToggleAllCompétences('{{ psNomType_Res }}', this);
			});
			
			if ($('#fEntityForm_seriesseances_lexclutsamedi').prop("checked")) {
				$("#entityFormBaseGrille_DataTable_Série tr:has(td:contains('Samedi'))").hide();
			}
			if ($('#fEntityForm_seriesseances_lexclutdimanche').prop("checked")) {
				$("#entityFormBaseGrille_DataTable_Série tr:has(td:contains('Dimanche'))").hide();
			}		
			
			if ($('#fEntityForm_seriesseances_lexclutjoursferies').prop("checked")) {
				var joursFeries = joursFeriesListe();
				for (var i=0; i < joursFeries.length; i++){
					$("#entityFormBaseGrille_DataTable_Série tr:has(td:contains('"+joursFeries[i]+"'))").hide();
				}			
			}	
			updateTableau();
        });
        function ajoutSerie(listeSerie){
				{% block datatable_body %}
					var listeSéancesRéelles = [];
					var datelisteSéancesRéelles = [];
					var datelisteSéancesPossibles = [];
					var seanceActuelle = {};
					var check;
					var dansSerieSansConflit;
					var disabled;
					var horaireDebut;
					var horaireFin;
					var ressourceSéance = '';
					{% set iRow = 0 %}
					{% for seance in lsLstInfos %}
						listeSéancesRéelles[{{iRow}}] = {'idSeance' :{{seance.iid_seance}},
								'idSerie' :{{seance.iid_serie}},
								'tdebut' : '{{seance.tdebut}}',
								'tfin' : '{{seance.tfin}}',
                                'cLblLstRes' : '{{seance.clbllstres}}'
						};
{#						console.log(listeSéancesRéelles[{{iRow}}].tdebut);#}
					{% set iRow = iRow + 1%}
					{% endfor %}
{#						debugger;#}
						seanceActuelle = {'idSeance' : {{poSéance.id}},
							'tdebut' : '{{poSéance.tdebut|date('d/m/Y H:i:s')}}',
							'tfin' : '{{poSéance.tfin|date('d/m/Y H:i:s')}}',
					};
					$('#entityFormBaseGrille_DataTable_Série > tbody > tr').remove();
					for (var i = 0; i < listeSéancesRéelles.length; i++){
						datelisteSéancesRéelles[i] = window.oPaa.getDate(listeSéancesRéelles[i].tdebut, 'DD/MM/YYYY');						
					}
					for (var i = 0; i < listeSerie.length; i++){
						var nomJour = CDOW(new Date(listeSerie[i]));
						datelisteSéancesPossibles[i] = window.oPaa.getDate(listeSerie[i], 'DD/MM/YYYY');
						//MG 20200519 Modification Début
						{#if (datelisteSéancesPossibles.some(r => datelisteSéancesRéelles.indexOf(r) >= 0)){#}
						if (datelisteSéancesRéelles.includes(datelisteSéancesPossibles[i])){
						//MG 20200519 Modification Fin
							horaireDebut = listeSéancesRéelles[i].tdebut.substring(11);
							horaireFin = listeSéancesRéelles[i].tfin.substring(11);
							ressourceSéance = listeSéancesRéelles[i].cLblLstRes;
							check = 'checked'
							disabled = '';
							dansSerieSansConflit = 'class="dansSerieSansConflit"';
		
							if(datelisteSéancesPossibles[i] == $('.selected td:contains("/")').text().trim()){
								disabled = 'disabled';
								dansSerieSansConflit = 'class="seanceActuelle"';
								horaireDebut = seanceActuelle.tdebut.substring(11);
								horaireFin = seanceActuelle.tfin.substring(11);
							}
						} else {
							check = '';
							dansSerieSansConflit = 'class="horsSerie"';
							horaireDebut = seanceActuelle.tdebut.substring(11);
							horaireFin = seanceActuelle.tfin.substring(11);
						}
						var nouvelleSerie = '<tr '+dansSerieSansConflit+'>\n\
												<td id ="row_tri_' + i + '" style="display: none"></td>\n\
												<td id ="row_selectionner_' + i + '">\n\
														<input class="EFControl"\n\
																type="checkbox"\n\
																id = "testcheckbox"\n\
																	{% if(psType_Res == "C") %}\n\
																		name="Coche{{psType_Res}}_{{ row.iid_actibase }}"\n\
																		value="{{ row.iid_actibase }}"\n\
																	{% else %}\n\
																		name="Coche"\n\
																		value=""\n\
																	{% endif %}\n\
																' + check + ' ' + disabled + '\n\
														>\n\
												</td>\n\
												<td id ="row_cdate_' + i + '">\n\
														' + nomJour.charAt(0).toUpperCase() + nomJour.slice(1) + ' ' + datelisteSéancesPossibles[i] + '\n\
												</td>\n\
												<td id ="row_mdebut_' + i + '">\n\
													{# LG 20200601 deac {{lsLstInfos[0].tdebut|slice(11)|trim('"')}}#}\n\
													'+horaireDebut+'\n\
												</td>\n\
												<td id ="row_mfin_' + i + '">\n\
													{# LG 20200601 deac {{lsLstInfos[0].tfin|slice(11)|trim('"')}}#}\n\
													'+horaireFin+'\n\
												</td>\n\
												<td id ="row_clbllstres_' + i + '">\n\
													{# LG 20200601 deac {{lsLstInfos[0].clbllstres}}#}\n\
													'+ressourceSéance+'\n\
												</td>\n\
											</tr>';
						$('#entityFormBaseGrille_DataTable_Série > tbody').append(nouvelleSerie);
				{#				{% set iRow = iRow + 1%}#}
					}
				{% endblock %}
				updateRecurrence();
				$('#entityFormBaseGrille_DataTable_Série tr input').click(updateCoche);
            }
			
			
			//MG Ajout 20200519 Début
            $('#fEntityForm_seriesseances_lexclutsamedi').on('click', exclureSamedis);
            $('#fEntityForm_seriesseances_lexclutdimanche').on('click', exclureDimanches);
            $('#fEntityForm_seriesseances_lexclutjoursferies').on('click', exclureJoursFeries);
{#			$('#entityFormBaseGrille_DataTable_Série tr input').click(updateCoche);#}
			
			
			function exclureSamedis(milli = 500){
				if ($('#fEntityForm_seriesseances_lexclutsamedi').prop("checked")) {
					$("#entityFormBaseGrille_DataTable_Série tr:has(td:contains('Samedi'))").hide(milli);
				} else {
					if(!($('#fEntityForm_seriesseances_ifrequence').val() == "7") && !($('#fEntityForm_seriesseances_ifrequence').val() == "8")){
						$("#entityFormBaseGrille_DataTable_Série tr:has(td:contains('Samedi'))").show(milli);
					}
				}
			}
			
			function exclureDimanches(milli = 500){
				if ($('#fEntityForm_seriesseances_lexclutdimanche').prop("checked")) {
					$("#entityFormBaseGrille_DataTable_Série tr:has(td:contains('Dimanche'))").hide(milli);
				} else {
					if(!($('#fEntityForm_seriesseances_ifrequence').val() == "7") && !($('#fEntityForm_seriesseances_ifrequence').val() == "8")){
						$("#entityFormBaseGrille_DataTable_Série tr:has(td:contains('Dimanche'))").show(milli);
					}
				}
			}
			
			function exclureJoursFeries(milli = 500){
				var joursFeries = joursFeriesListe();
				for(var i=0; i < joursFeries.length; i++){
					if ($('#fEntityForm_seriesseances_lexclutjoursferies').prop("checked")) {
						$("#entityFormBaseGrille_DataTable_Série tr:has(td:contains('"+joursFeries[i]+"'))").hide(milli);
					} else {
						if(!($('#fEntityForm_seriesseances_ifrequence').val() == "7") && !($('#fEntityForm_seriesseances_ifrequence').val() == "8")){
							$("#entityFormBaseGrille_DataTable_Série tr:has(td:contains('"+joursFeries[i]+"'))").show(milli);
						}
					}
				}				
			}
			
			function updateCoche(){
				if($(this).prop("checked")) {
					if($(this).closest('tr').attr('class') === "horsSerie"){
						$(this).closest('tr').removeClass().addClass('horsSerieAjout');
					} else if ($(this).closest('tr').attr('class') === "dansSerieSuppression"){
						$(this).closest('tr').removeClass().addClass('dansSerieSansConflit');
					} else if ($(this).closest('tr').attr('class') === "dansSerieSuppressionAvecConflit"){
						$(this).closest('tr').removeClass().addClass('dansSerieAvecConflit');
					}
				} else if (!$(this).prop("checked")) {
					if($(this).closest('tr').attr('class') === "dansSerieSansConflit"){
						$(this).closest('tr').removeClass().addClass('dansSerieSuppression');
					} else if ($(this).closest('tr').attr('class') === "dansSerieAvecConflit"){
						$(this).closest('tr').removeClass().addClass('dansSerieSuppressionAvecConflit');
					} else if ($(this).closest('tr').attr('class') === "horsSerieAjout"){
						$(this).closest('tr').removeClass().addClass('horsSerie');
					}
				}
			}
			
            $('#cbo2Dates2').on('change', function(){
				updateTableau();
            });
			
            function updateTableau(){
				var dateDebut = $('#cbo2Dates2').val().slice(0, 10);
				var dateFin = $('#cbo2Dates2').val().slice(13, 24);
				dateListe(dateDebut, dateFin);
            }

            function dateListe(dateDebut, dateFin){
				//MG modification 20200519 Début
				{#var jourDebut = dateDebut.split('/')[0];
				var moisDebut = dateDebut.split('/')[1] - 1;
				var anneeDebut = dateDebut.split('/')[2];
				var jourFin = dateFin.split('/')[0];
				var moisFin = dateFin.split('/')[1] - 1;
				var anneeFin = dateFin.split('/')[2];
				dateDebut = new Date(anneeDebut, moisDebut, jourDebut);
				dateFin = new Date(anneeFin, moisFin, jourFin);
				var dateListe = new Array();
				while (dateDebut < dateFin) {					
					dateListe.push(new Date(dateDebut));
					dateDebut = dateDebut.setDate(dateDebut.getDate() + 1);
				}#}
				dateDebut = dateDebut.split('/').reverse().join('-');
				dateFin = dateFin.split('/').reverse().join('-');
				var dateListe = []
				dateListe = window.oPaa.getDatesBetween(dateDebut, dateFin, 'YYYY-MM-DD');
				//MG modification 20200519 Fin
				ajoutSerie(dateListe);
				exclureSamedis(0);
				exclureDimanches(0);
				exclureJoursFeries(0);
            }
			
			//MG Ajout 20200518 Début
			function joursFeriesListe(){
				var joursFeries = [];
				var joursVacances = [];
				{% for dates in lstJoursFeries %}
					{% if dates.ddatefin is null %}
						joursFeries.push('{{dates.ddate}}');
					{% else %}
						joursVacances = window.oPaa.getDatesBetween('{{dates.ddate}}', '{{dates.ddatefin}}', 'YYYY-MM-DD');
						for (var i=0; i< joursVacances.length; i++){
							joursFeries.push(joursVacances[i]);
						}
					{% endif %}				
				{% endfor %}
				for (var i=0; i < joursFeries.length; i++){
					joursFeries[i] = window.oPaa.getDate(joursFeries[i], 'DD/MM/YYYY');
				}
				return joursFeries;
			}
			//MG Ajout 20200518 Fin
			
			//MG Ajout 20200525 Début			
			$('#fEntityForm_seriesseances_ifrequence').on('change', updateRecurrence);
			function updateRecurrence(){
				$("#entityFormBaseGrille_DataTable_Série tr:not(.dansSerieSansConflit)").hide();				
				var longueurTable = $("#entityFormBaseGrille_DataTable_Série tr").length;
				switch($('#fEntityForm_seriesseances_ifrequence').val()){
					case "1":
						$("#entityFormBaseGrille_DataTable_Série tr:nth-child(n)").show();
						exclureSamedis(0);
						exclureDimanches(0);
						exclureJoursFeries(0);
						break;
					
					case "2":
						$("#entityFormBaseGrille_DataTable_Série tr:nth-child(2n+1)").show();
						exclureSamedis(0);
						exclureDimanches(0);
						exclureJoursFeries(0);
						break;
						
					case "3":
						$("#entityFormBaseGrille_DataTable_Série tr:nth-child(3n+1)").show();
						exclureSamedis(0);
						exclureDimanches(0);
						exclureJoursFeries(0);
						break;
						
					case "4":
						$("#entityFormBaseGrille_DataTable_Série tr:nth-child(7n+1)").show();
						exclureSamedis(0);
						exclureDimanches(0);
						exclureJoursFeries(0);
						break;
						
					case "5":
						$("#entityFormBaseGrille_DataTable_Série tr:nth-child(14n+1)").show();
						exclureSamedis(0);
						exclureDimanches(0);
						exclureJoursFeries(0);
						break;
						
					case "7":
						$("#entityFormBaseGrille_DataTable_Série tr:has(td:contains('Lundi'), :contains('Jeudi'))").show();
						exclureJoursFeries(0);
						break;
						
					case "8":
						$("#entityFormBaseGrille_DataTable_Série tr:has(td:contains('Mardi'), :contains('Vendredi'))").show();
						exclureJoursFeries(0);
						break;
						
					default:
						break;
				}
			}
			//MG Ajout 20200525 Fin
			
    </script>
{% endblock %}
{#MG Modification Fin 20200217#}
